/*
  Description: This is the test 1 of PIC16F1827 Dev. board
  MCU: PIC16F1827, 500 KHz internal clock, MCLR enabled
  Jun 15, 2011
  
*/

// Define LCD connections
sbit LCD_RS at RA6_bit;
sbit LCD_EN at RA7_bit;
sbit LCD_D4 at RA0_bit;
sbit LCD_D5 at RA1_bit;
sbit LCD_D6 at RA2_bit;
sbit LCD_D7 at RA3_bit;
sbit LCD_RS_Direction at TRISA6_bit;
sbit LCD_EN_Direction at TRISA7_bit;
sbit LCD_D4_Direction at TRISA0_bit;
sbit LCD_D5_Direction at TRISA1_bit;
sbit LCD_D6_Direction at TRISA2_bit;
sbit LCD_D7_Direction at TRISA3_bit;
// End LCD module connections

// Define Messages
 char message1[] = "Testing";
 char message2[] = "LCD";
 char message3[] = "LEDs";
 char message4[] = "Press SW";
 char message5[] = "I/O Test";
 char message6[] = "Complete";

 void delay2s(){
  Delay_ms(2000);
 }

unsigned short i, j, temp;
void main() {

 TRISA = 0b00100000; // PORTA output except RA5
 TRISB = 0x00;       // PORTB all output
 ANSELA = 0x00;      // Disable any analog functions in PORTA
 ANSELB = 0x00;      // Disable any analog functions in PORTB
 LATB = 0x00;        //PORTB all zeros
// Test LCD connections
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);             // CLEAR display
 Lcd_Cmd(_LCD_CURSOR_OFF);        // Cursor off
 Lcd_Out(1,1,message1);           // Write message1 in 1st row
 Lcd_Out(2,1,message2);           // Write message1 in 2nd row
 delay2s();
 
 // Test LEDs
 Lcd_Cmd(_LCD_CLEAR);             // CLEAR display
 Lcd_Out(1,1,message1);           // Write message1 in 1st row
 Lcd_Out(2,1,message3);           // Write message3 in 2nd row
 temp = 0x01;
 for (i = 0; i<7; i++) {
  PORTB = temp;
  Delay_ms(200);
  temp = temp << 1;
 }
 for (i = 0; i<8; i++) {
  PORTB = temp;
  Delay_ms(200);
  temp = temp >> 1;
 }
 
 // Test Tact switches
 Lcd_Cmd(_LCD_CLEAR);       // CLEAR display
 Lcd_Out(1,1,message4);
 TRISB = 0xFF;              // PORTB I/P
 for (i = 0; i< 6; i++){
  while (PORTB > 62)        // while Key is not pressed, do nothing
   Delay_1us();
  temp = PORTB;
  temp = temp^63;
  Delay_ms(300);
  switch (temp) {
    case 1 : j = 1;
             break;
    case 2 : j = 2;
             break;
    case 4 : j = 3;
             break;
    case 8 : j = 4;
             break;
    case 16 : j = 5;
             break;
    case 32 : j = 6;
             break;
    } //case end
  Lcd_Chr(2, 1, j+48);
 }

 // Test1 Complete
 Lcd_Cmd(_LCD_CLEAR);       // CLEAR display
 Lcd_Out(1,1,message5);
 Lcd_Out(2,1,message6);
 
 
}