

sbit Soft_I2C_Scl at RB4_bit;
sbit Soft_I2C_Sda at RB5_bit;
sbit Soft_I2C_Scl_Direction at TRISB4_bit;
sbit Soft_I2C_Sda_Direction at TRISB5_bit;

unsigned char MyError, Temp;
unsigned short num;
const int TC74A0 = 0x90, EEPROM = 0xA0, MCP23008 = 0x40;

void newline(){
  UART1_Write(13); // Carriage Return
  UART1_Write(10); // Line Feed
}

void check_device(unsigned short dev_address){
 Soft_I2C_Start();
 if (Soft_I2C_Write(dev_address)){
  UART1_Write_Text("Device Not Found! ");
  newline();
 }
 else {
 UART1_Write_Text("Device Found ");
 newline();
 }
 Soft_I2C_Stop();
}

unsigned short Read_Temp(){
 unsigned short result;
 Soft_I2C_Start(); // Issue start signal
 Soft_I2C_Write(TC74A0); // Address + Write bit
 Soft_I2C_Write(0x00); // Read Temp
 Soft_I2C_Start(); // Issue start signal
 Soft_I2C_Write(TC74A0+1); // Address + Read bit
 result = Soft_I2C_Read(0);
 return result;
}

char temperature[] = "00  C";
void main() {

 ANSELB = 0x00;       // Disable analog functions
 TRISB = 0b00000010;
 APFCON1 = 0x01;
 APFCON0 = 0x80;
 UART1_Init(9600);
 Delay_ms(100);
 Soft_I2C_Init();   // Initiate I2C
 
 // Test UART
 UART1_Write_Text("Testing UART! ");
 newline();

 UART1_Write_Text("Type in a Number: ");
 while(!UART1_Data_Ready());
 Temp = UART1_Read();
 newline();
 UART1_Write_Text("You entered: ");
 UART1_Write(Temp);
 newline();

 UART1_Write_Text("Testing I2C devices... ");
 newline();
 UART1_Write_Text("EEPROM... ");
 check_device(EEPROM);
 UART1_Write_Text("MCP23008... ");
 check_device(MCP23008);
 UART1_Write_Text("TC74A0... ");
 check_device(TC74A0);
 UART1_Write_Text("Reading temperature from TC74A0... ");
 num = Read_Temp();
 temperature[0] = num/10 + 48;
 temperature[1] = num%10 + 48;
 temperature[3] = 223;
 UART1_Write_Text(temperature);
 

}